(defvar treesit--recursive-scan-call nil)

(define-advice scan-lists (:around (ofun from count depth) treesit)
  (if (or treesit--recursive-scan-call (not treesit-thing-settings))
      (funcall ofun from count depth)
    (save-excursion
      (goto-char from)
      (let ((treesit--recursive-scan-call t))
        (cond ((= depth 0)
               (treesit-forward-list count)
               (point))
              ((< depth 0)
               (when (treesit-forward-list count)
                 (let* ((node (if (> count 0)
                                  (treesit-thing-prev (point) 'sexp-list)
                                (treesit-thing-next (point) 'sexp-list)))
                        (beg-node (when node (treesit-node-child node 0))))
                   (when beg-node
                     (treesit-node-end beg-node)))))
              ((> depth 0)
               (let ((node (treesit-thing-at (point) 'sexp-list)))
                 (while (and node (eq (point) (treesit-node-start node)))
                   (setq node (treesit-parent-until node 'sexp-list)))
                 (when node (treesit-node-start node)))))))))

(define-advice scan-sexps (:around (ofun from count) treesit)
  (if (or treesit--recursive-scan-call (not treesit-thing-settings))
      (funcall ofun from count)
    (save-excursion
      (goto-char from)
      (let ((treesit--recursive-scan-call t))
        (treesit-forward-sexp-list count))
      (point))))

(define-advice treesit-major-mode-setup (:after (&rest _) reset)
  (setq-local forward-sexp-function nil))
